(**
   This is a module for renaming.
   @author Naoki Nishida
   @since 2012/01/12
*)

open Variable;;
open Ctrs;;

(**
   This produces a variable renaming for [xs].
*)
let rec gen_renaming =
  function
      [] -> []
    | x::xs -> 
	if List.mem x xs
	then gen_renaming xs
	else (x,Node(Var gen_var#generate,[]))::(gen_renaming xs);;

(**
   This renames variables in a rule.
*)
let rename_rule rl =
  let xs = vars_in_rule rl in
  let delta = gen_renaming xs in
  apply_subst_to_rule delta rl;;
